clc
clear

ExcelFilename = 'newtonDivDiff.xlsx';
% test f(x) = log(x)
fprintf('----------------------------------- log(x)\n');
x=1:5;
y = log(x);

xint = 1.5:4.5;
yintc = log(xint);
fprintf('xint = \n');
disp(xint);
fprintf('yintc = \n');
disp(yintc);
yint = zeros(length(xint),1);
percerr = zeros(length(xint),1);
for i=1:length(xint)
  yint(i) = newtonDivDiff(x,y,xint(i));
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr');
yint1 = yint;
percerr1 = percerr;

p = 0.5;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint2 = yint;
percerr2 = percerr;

p = 0.1;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint3 = yint;
percerr3 = percerr;

n = length(xint);
X = x(1:n)';
Y = y(1:n)';
zVarNames = {'X','Y','Xint','Yint','Yint1','PercnErr1','Yint2','PercnErr2','Yint3','PercnErr3'};
T = table(X,Y,xint',yintc',yint1,percerr1,yint2,percerr2,yint3,percerr3,'VariableNames',zVarNames);
writetable(T, ExcelFilename, 'Sheet','log');

% test f(x) = log(x^2+1)
fprintf('----------------------------------- log(x^2+1)\n');
x=1:5;
y = log(x.^2+1);

xint = 1.5:4.5;
yintc = log(xint.^2+1);
fprintf('xint = \n');
disp(xint);
fprintf('yintc = \n');
disp(yintc);
yint = zeros(length(xint),1);
percerr = zeros(length(xint),1);
for i=1:length(xint)
  yint(i) = newtonDivDiff(x,y,xint(i));
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr');
yint1 = yint;
percerr1 = percerr;

p = 0.5;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint2 = yint;
percerr2 = percerr;

p = 0.1;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint3 = yint;
percerr3 = percerr;

n = length(xint);
X = x(1:n)';
Y = y(1:n)';
zVarNames = {'X','Y','Xint','Yint','Yint1','PercnErr1','Yint2','PercnErr2','Yint3','PercnErr3'};
T = table(X,Y,xint',yintc',yint1,percerr1,yint2,percerr2,yint3,percerr3,'VariableNames',zVarNames);
writetable(T, ExcelFilename, 'Sheet','log(x2 plus 1)');


% test f(x) = gamma(x)/gamma(x+1)
fprintf('----------------------------------- gamma(x)/gamma(x+1)\n');
x=2:6;
y = gamma(x)./gamma(x+1);

xint = 2.5:5.5;
yintc = gamma(xint)./gamma(xint+1);
fprintf('xint = \n');
disp(xint);
fprintf('yintc = \n');
disp(yintc);
yint = zeros(length(xint),1);
percerr = zeros(length(xint),1);
for i=1:length(xint)
  yint(i) = newtonDivDiff(x,y,xint(i));
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr');
yint1 = yint;
percerr1 = percerr;

p = 0.5;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint2 = yint;
percerr2 = percerr;

p = 0.1;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint3 = yint;
percerr3 = percerr;

n = length(xint);
X = x(1:n)';
Y = y(1:n)';
zVarNames = {'X','Y','Xint','Yint','Yint1','PercnErr1','Yint2','PercnErr2','Yint3','PercnErr3'};
T = table(X,Y,xint',yintc',yint1,percerr1,yint2,percerr2,yint3,percerr3,'VariableNames',zVarNames);
writetable(T, ExcelFilename, 'Sheet','gamma ratio');




% test f(x) = 1/x
fprintf('----------------------------------- 1/x\n');
x=1:5;
y = 1./x;

xint = 1.5:4.5;
yintc = 1./xint;
fprintf('xint = \n');
disp(xint);
fprintf('yintc = \n');
disp(yintc);
yint = zeros(length(xint),1);
percerr = zeros(length(xint),1);
for i=1:length(xint)
  yint(i) = newtonDivDiff(x,y,xint(i));
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr');
yint1 = yint;
percerr1 = percerr;

p = 0.5;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint2 = yint;
percerr2 = percerr;

p = 0.1;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint3 = yint;
percerr3 = percerr;

n = length(xint);
X = x(1:n)';
Y = y(1:n)';
T = table(X,Y,xint',yintc',yint1,percerr1,yint2,percerr2,yint3,percerr3,'VariableNames',zVarNames);
writetable(T, ExcelFilename, 'Sheet','recip');

% test f(x) = sqrt(x)
fprintf('----------------------------------- sqrt(x)\n');
x=2:6;
y = sqrt(x);

xint = 2.5:5.5;
yintc = sqrt(xint);
fprintf('xint = \n');
disp(xint);
fprintf('yintc = \n');
disp(yintc);
yint = zeros(length(xint),1);
percerr = zeros(length(xint),1);
for i=1:length(xint)
  yint(i) = newtonDivDiff(x,y,xint(i));
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr');
yint1 = yint;
percerr1 = percerr;

p = 0.5;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint2 = yint;
percerr2 = percerr;

p = 0.1;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint3 = yint;
percerr3 = percerr;

n = length(xint);
X = x(1:n)';
Y = y(1:n)';
T = table(X,Y,xint',yintc',yint1,percerr1,yint2,percerr2,yint3,percerr3,'VariableNames',zVarNames);
writetable(T, ExcelFilename, 'Sheet','sqrt');


% test f(x) = Pade1(x)
fprintf('----------------------------------- Pade1(x)\n');
x=2:0.5:4;
y = pade1(x);

xint = 2.25:0.5:3.75;
yintc = pade1(xint);
fprintf('xint = \n');
disp(xint);
fprintf('yintc = \n');
disp(yintc);
yint = zeros(length(xint),1);
percerr = zeros(length(xint),1);
for i=1:length(xint)
  yint(i) = newtonDivDiff(x,y,xint(i));
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr');
yint1 = yint;
percerr1 = percerr;

p = 0.5;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint2 = yint;
percerr2 = percerr;

p = 0.1;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint3 = yint;
percerr3 = percerr;
n = length(xint);
X = x(1:n)';
Y = y(1:n)';
T = table(X,Y,xint',yintc',yint1,percerr1,yint2,percerr2,yint3,percerr3,'VariableNames',zVarNames);
writetable(T, ExcelFilename, 'Sheet','pade1');

% test f(x) = pade2(x))
fprintf('----------------------------------- pade2(x)\n');
x=2:0.5:4;
y = pade2(x);

xint = 2.25:0.5:3.75;
yintc = pade2(xint);
fprintf('xint = \n');
disp(xint);
fprintf('yintc = \n');
disp(yintc);
yint = zeros(length(xint),1);
percerr = zeros(length(xint),1);
for i=1:length(xint)
  yint(i) = newtonDivDiff(x,y,xint(i));
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr');
yint1 = yint;
percerr1 = percerr;

p = 0.5;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint2 = yint;
percerr2 = percerr;

p = 0.1;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint3 = yint;
percerr3 = percerr;
n = length(xint);
X = x(1:n)';
Y = y(1:n)';
T = table(X,Y,xint',yintc',yint1,percerr1,yint2,percerr2,yint3,percerr3,'VariableNames',zVarNames);
writetable(T, ExcelFilename, 'Sheet','pade2');

% test f(x) = trigFx1(x)
fprintf('----------------------------------- trigXf1(x)\n');
x=2:0.5:4;
y = trigFx1(x);

xint = 2.25:0.5:3.75;
yintc = trigFx1(xint);
fprintf('xint = \n');
disp(xint);
fprintf('yintc = \n');
disp(yintc);
yint = zeros(length(xint),1);
percerr = zeros(length(xint),1);
for i=1:length(xint)
  yint(i) = newtonDivDiff(x,y,xint(i));
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr');
yint1 = yint;
percerr1 = percerr;

p = 0.5;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint2 = yint;
percerr2 = percerr;

p = 0.1;
for i=1:length(xint)
  yint(i) = newtonDivDiff(x.^p,y,xint(i)^p);
  percerr(i) = 100*(yint(i) - yintc(i))/yintc(i);
end
fprintf('------------------ using power %f\n', p);
fprintf('xint = \n');
disp(xint);
fprintf('yint = \n');
disp(yint');
fprintf('%%error = \n');
disp(percerr')
yint3 = yint;
percerr3 = percerr;
n = length(xint);
X = x(1:n)';
Y = y(1:n)';
T = table(X,Y,xint',yintc',yint1,percerr1,yint2,percerr2,yint3,percerr3,'VariableNames',zVarNames);
writetable(T, ExcelFilename, 'Sheet','trig fx1');

function y = pade1(x)
  y = (x.^3-2*x.^2+3*x-4)./(x.^2+x+1);
end

function y = pade2(x)
  y = (x.^2+5*x+10)./(x.^3+x.^2+x+1);
end

function y = trigFx1(x)
  y = (5*x.^2 + sin(x))./(3*x.^2 + cos(x));
end